#include <windows.h>
#include <stdlib.h>
#include "threads.h"
#include "resource.h"


HANDLE hInst;
HANDLE hMainWnd;

MYTHREAD ThreadInfo [NTHREADS]  ;		// Array to keep track of thread info


int WINAPI WinMain (HANDLE hInstance, HANDLE hPrevInstance, 
	LPSTR  lpCmdLine, int    nCmdShow)
{
  MSG  msg;
  WNDCLASS wc;
  int i ;
  BYTE Red, Green, Blue ;
  UNREFERENCED_PARAMETER( lpCmdLine );
  UNREFERENCED_PARAMETER( hPrevInstance );

/*
initialize thread handle and ID array
*/

	for (i = 0 ; i < NTHREADS ; i ++)
	{
		Red = 255 * (i & 0x01) ;
		Green = 255 * ((i & 0x02)>>1) ; 
		Blue = 255 *  ((i & 0x04)>>2) ;

		ThreadInfo[i].hThread = 0 ;
		ThreadInfo[i].Id = 0 ;
		ThreadInfo[i].Color = RGB (Red, Green, Blue) ;
	}

  hInst = hInstance;

  wc.style = CS_VREDRAW | CS_HREDRAW;                          
  wc.lpfnWndProc = (WNDPROC)MainWndProc ; 
  wc.cbClsExtra = 0 ;
  wc.cbWndExtra = 0 ;
  wc.hInstance = hInstance ;
  wc.hIcon = LoadIcon (NULL, IDI_APPLICATION) ;
  wc.hCursor = LoadCursor (NULL, IDC_ARROW) ;
  wc.hbrBackground = GetStockObject (BLACK_BRUSH) ;
  wc.lpszMenuName = "Thread_Menu" ;
  wc.lpszClassName = "ThreadsWClass" ;

  RegisterClass(&wc);

                                      
  hMainWnd = CreateWindow ("ThreadsWClass",
                       "Ejemplo de operaciones sobre hebras",
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT,
                       CW_USEDEFAULT,
                       CW_USEDEFAULT,
                       CW_USEDEFAULT,
                       NULL,
                       NULL,
                       hInstance,
                       NULL);


  ShowWindow(hMainWnd, nCmdShow);
  while (GetMessage (&msg, NULL, 0, 0))
    DispatchMessage (&msg);   // Dispatch message to window.

  return (msg.wParam);           // Returns value from PostQuitMessage.

}
